package strategy;

import java.util.*;

public class T06_Murakami_spreadStrategy extends Strategy {

    private Random random;
    private int maxPosition = 300;
    
    public T06_Murakami_spreadStrategy(int seed) {
            random = new Random(seed);
        }

	public Order getOrder(int[] spotPrices, int[] futurePrices, int pos,
			long money, int restDay) {

		Order order = new Order();
		
  //buysell,quant pricě
		setOrderBuySell(order, spotPrices, futurePrices);
		setQuant(order, spotPrices, futurePrices);
		setPrice(order, spotPrices, futurePrices);
		setMaxPosition(order, futurePrices, pos);
		return order;
	}
	public void setOrderBuySell(Order order, int[] spotPrices, int[] futurePrices){
		  int latestFuturePrice = futurePrices[59];	
		  int latestSpotPrice =spotPrices[119];
		  if ( latestSpotPrice <= 0 || latestFuturePrice < 0 ) {
		    order.buysell = Order.NONE;
		  	}
		  int spreadPrice =latestSpotPrice - latestFuturePrice ;
		  	if(spreadPrice > 25){
		  		order.buysell = 2;
		  	}else if(spreadPrice < -25){
		  		order.buysell = 1;
		  	}else{
		  		order.buysell = 0;
		  	}
	}
	public void setQuant(Order order, int[] spotPrices, int[] futurePrices){
		int spread = Math.abs(spotPrices[119] - futurePrices[59]);
  		if(spread > 200){
  			order.quant = 200;
  		}else if(spread > 100){
  			order.quant = 100;
  		}else if(spread > 50){
  			order.quant = 30;
  		}else if(spread > 40){
  			order.quant = 25;
  		}else if(spread > 30){
  			order.quant = 20;
  		}else if(spread > 25){
  			order.quant = 10;
  		}
	}
	public void setPrice(Order order,int[] spotPrices, int[] futurePrices){
	     if(order.buysell == 2){
	      	order.price = futurePrices[59] + 30;	
	      }else if(order.buysell == 1){
	      	order.price = futurePrices[59] - 30;
	      }
	}   
	public Order setMaxPosition(Order order, int[] futurePrices, int pos){
		if( order.buysell == Order.BUY ) {
		    if( pos > maxPosition ) {
			order.buysell = Order.NONE;
		    }
		} else if ( order.buysell == Order.SELL ) {
		    if( pos < -maxPosition ) {
			order.buysell = Order.NONE;
		    }
		}return order;
	}
}