//Program written by Takashi ASAHINA(Kinki Univ)

package strategy;
import java.util.*;
public class TestStrategy extends Strategy {
    private Random random;
    private final int widthOfPrice = 20;
    private final int maxQuant = 75;
    private final int minQuant = 30;
    private final int maxPosition = 300;

    public TestStrategy(int seed) {
	random = new Random(seed);
    }

    public void action( int[] spotPrices, int[] futurePrices, 
			int pos, long money, int restDay ) {
	Order order = getOrder(spotPrices, futurePrices, pos, money, restDay);
	orderRequest(order);
    }
    
    public Order getOrder( int[] spotPrices, int[] futurePrices, 
		           int pos, long money, int restDay ) {

	Order order = new Order();

//敨Zړ(5)
	double movingAveragef = 0.0;
	int countf = 0;
	for(int i = 0; i<5; ++i){
	    if( futurePrices[futurePrices.length - 1 - i] > 0 ) {
		movingAveragef += futurePrices[futurePrices.length - 1 - i];
		countf++;
	    }
	}
//Zړ(5)
	double movingAverages = 0.0;
	int counts = 0;
	for( int i = 0; i < 5; ++i ) {
	    if( spotPrices[spotPrices.length - 1 - i] >= 0 ) {  
		movingAverages += spotPrices[spotPrices.length - 1 - i];
		++counts;
	    }
	}
//敨ړρi15j
	double movingAveragel = 0.0;
	int countl = 0;
	for(int i = 0; i<15; ++i){
	    if( futurePrices[futurePrices.length - 1 - i] > 0 ) {
		movingAveragel += futurePrices[futurePrices.length - 1 - i];
		countl++;
	    }
	}

	if( countf == 0 ) {
	    order.buysell = Order.NONE;
	    return order;
	}
	
	if( counts == 0 ) {
	    order.buysell = Order.NONE;
	    return order;
	}

	if( countl == 0 ) {
	    order.buysell = Order.NONE;
	    return order;
	}

	movingAveragef = (int)(movingAveragef / (double)countf);
    movingAverages = (int)(movingAverages / (double)counts);
	movingAveragel = (int)(movingAveragel / (double)countl);

	int prevPricef = getLatestPrice( futurePrices );
	int prevPrices = getLatestPrice( spotPrices );
	
	double futurePricegap = Math.abs(movingAveragef - prevPricef);
	double spotPricegap = Math.abs(movingAverages - prevPrices);

//l肪傫̓
	if (movingAveragef < movingAveragel*0.9){
		order.buysell = Order.BUY;
	    order.price = (prevPricef);
		order.quant = 200;
		return order;
    }
//lオ肪傫̓
	if (movingAveragef > movingAveragel*1.1){
		order.buysell = Order.SELL;
	    order.price = (prevPricef);
		order.quant = 200;
		return order;
    }
//ʏ펞̓
	if (futurePricegap >= spotPricegap){
		if ( prevPricef > movingAveragef ) {
		    order.buysell = Order.BUY;
		} else if( prevPricef < movingAveragef ) {
	   	    order.buysell = Order.SELL;
			} else {
	    		order.buysell = Order.NONE;
	    		return order;
			}
	    
				}
	if (futurePricegap < spotPricegap){
			if ( prevPrices > movingAverages ) {
	    	     	   order.buysell = Order.BUY;
			} else if( prevPrices < movingAverages ) {
	    	           order.buysell = Order.SELL;
				} else {
	    	     		order.buysell = Order.NONE;
	    			return order;
				}
	}

	if( order.buysell == Order.BUY ) {
	    if( pos > maxPosition ) {
		order.buysell = Order.NONE;
		return order;
	    }
	} else if ( order.buysell == Order.SELL ) {
	    if( pos < -maxPosition ) {
		order.buysell = Order.NONE;
		return order;
	    }
	}
	

	while ( true ) {
	    order.price = ((prevPricef + prevPrices)/2 + (int)(widthOfPrice * random.nextGaussian()));
	    if ( order.price > 0.0 ) 
		break;
	}
	order.quant = minQuant + random.nextInt( maxQuant - minQuant +1);
	    
	return order;
    }
}
