package strategy;

import java.util.*;

public class Osako_pivotStrategy extends Strategy {

	private Random random;

	public Osako_pivotStrategy(int seed) {
		random = new Random(seed);
	}

	public Order getOrder(int[] spotPrices, int[] futurePrices, int pos,
			long money, int restDay) {

		Order order = new Order();
		//̍ŏ̔񂹎̂ݎ(̔񂹉񐔂4Ƃꍇ)
		int transactionPoint = restDay % 5;
		if (transactionPoint == 0) {
			if (restDay != 240) {    //ŏ4Ԃ͉Ȃ
				//buysell,quant,pricě
				setOrderBuySell(order, futurePrices, spotPrices, pos);
				setOrderQuant(order);
				setOrderPrice(order, futurePrices);
		} else {
			order.buysell = 0;
			}
		}	
		return order;
	}

	public void setOrderBuySell(Order order, int[] futurePrices,int[] spotPrices, int pos) {
		int latestFuturePrice = futurePrices[59];
		int latestSpotPrice = spotPrices[119];
		int prepos = Math.abs(pos);
		double maxPrice = getMax(futurePrices, 56, 59);  //̍ōl
		double minPrice = getMin(futurePrices, 56, 59);  //̍ňl
		double finalPrice = latestFuturePrice;           //Il
		//s{bg̎Zo
		double pivot = (maxPrice + minPrice + finalPrice) / 3;
		//T|[gC̔|CgƃWX^XC|Cg
		double supportLine1 = 2 * pivot - maxPrice;
		double resistanceLine1 = 2 * pivot - minPrice;
		double supportLine2 = pivot - resistanceLine1 + maxPrice;
		double resistanceLine2 = pivot - supportLine1 + resistanceLine1;
		//؂_
		double lowBreakOutPoint = 2 * pivot - 2 * minPrice + maxPrice;
		double highBreakOutPoint = 2 * pivot - 2 * maxPrice + minPrice;
		
		if((latestFuturePrice > 0) && (latestSpotPrice > 0)){
			//s{bgɐ敨iꍇ
			
			//Gg[
			if (latestFuturePrice < supportLine2) {
				order.buysell = 2;
				//؂
				if ((latestFuturePrice < lowBreakOutPoint) && (prepos > 100)) {
					order.buysell = 1;
				}
			//vo	
			}else if ((latestFuturePrice > supportLine1) && (prepos > 0)){
				order.buysell = 1;
				
			//s{bg艺ɐ敨iꍇ	
			//Gg[	
			} else if (latestFuturePrice > resistanceLine2) {
				order.buysell = 1;
				//؂
				if ((latestFuturePrice > highBreakOutPoint) && (prepos > 100)) {
					order.buysell = 2;
				}
			//vo	
			} else if((latestFuturePrice > resistanceLine1) && (prepos > 0)){	
				order.buysell = 2;	
			} else {
				order.buysell = 0;
				}
		}else{
			order.buysell = 0;
		}
	}

	public void setOrderQuant(Order order) {
		order.quant = 100;
	}

	public void setOrderPrice(Order order, int[] futurePrices) {
		if (order.buysell == 2) {
			order.price = futurePrices[59] + 50;
		} else if (order.buysell == 1) {
			order.price = futurePrices[59] - 50;
		}
	}
	//ōl̎Zo
	public double getMax(int[] theArray, int theStartIndex, int theEndIndex) {
		int maxpriceS = 0;
		for (int i = theStartIndex; i <= theEndIndex; i++) {
			if (maxpriceS <= theArray[i]) {
				maxpriceS = theArray[i];
			}
		}
		return maxpriceS;
	}
	//ŏl̎Zo
	public double getMin(int[] theArray, int theStartIndex, int theEndIndex) {
		int maxpriceS = 1000000;
		for (int i = theStartIndex; i <= theEndIndex; i++) {
			if (maxpriceS >= theArray[i]) {
				maxpriceS = theArray[i];
			}
		}
		return maxpriceS;
	}
}