package strategy;

import java.util.*;

public class Tabira_bolingerStrategy extends Strategy {

	private Random random;
	private int maxPosition = 150;
	private int edge1 = 10;
	private boolean lossCutFlag = false;

	public Tabira_bolingerStrategy(int seed) {
		random = new Random(seed);
	}

	public Order getOrder(int[] spotPrices, int[] futurePrices, int pos,
			long money, int restDay) {

				Order order = new Order();
				//buysell,quant,pricě
				setOrderBuySell(order, futurePrices, spotPrices, pos);
				setOrderQuant(order, pos);
				setOrderPrice(order, futurePrices);
				setMaxPosition(order, futurePrices, pos);
				return order;
	}

	public void setOrderBuySell(Order order, int[] futurePrices,int[] spotPrices, int pos) {
		int latestFuturePrice = futurePrices[59];
		int latestSpotPrice = spotPrices[119];
		double pricePowAverage1 = getPricePowAverage(futurePrices,52, 59);
		double pricePowAverage2 = getAverage(futurePrices,52,59);
		//W΍
		double standardDeviation = Math.sqrt(pricePowAverage1 - pricePowAverage2);
		//ړ
		int movingAverage= (int)getMovingAverage(futurePrices, 45, 59);
		//{W[oh
		int 2 =(int)( movingAverage + standardDeviation*2);
		int 1 = (int)(movingAverage + standardDeviation*1);
		int m1 = (int)(movingAverage - standardDeviation*1);
		int m2 = (int)(movingAverage - standardDeviation*2);
		
		if((latestFuturePrice > 0) && (latestSpotPrice > 0)){
			if(1 - edge1 > latestFuturePrice){
				order.buysell = 2;
				if(latestFuturePrice > 2){
					order.buysell = 1;
				}
			}else if(m1 + edge1 < latestFuturePrice){
				order.buysell = 1;
				if(latestFuturePrice < m2){
					order.buysell = 2;
				}
			}else{
				if((1 - edge1 > latestFuturePrice) || (m1 + edge1 < latestFuturePrice)){
					lossCutFlag = true;
					if(pos > 0){
						order.buysell = 2;
					}else if(pos < 0){
						order.buysell = 1;
					}else{
						order.buysell = 0;
					}
				}
			}
		}else{
			order.buysell = 0;
		}
	}

	public void setOrderQuant(Order order, int pos) {
		if(lossCutFlag){
			order.quant = (int)(Math.abs(pos)/2);
		}else{
			order.quant = 30;
		}
	}

	public void setOrderPrice(Order order, int[] futurePrices) {
		if (order.buysell == 2) {
			order.price = futurePrices[59] + 30;
		} else if (order.buysell == 1) {
			order.price = futurePrices[59] - 30;
		}
	}
	public Order setMaxPosition(Order order, int[] futurePrices, int pos){
		if( order.buysell == Order.BUY ) {
		    if( pos > maxPosition ) {
			order.buysell = Order.NONE;
		    }
		} else if ( order.buysell == Order.SELL ) {
		    if( pos < -maxPosition ) {
			order.buysell = Order.NONE;
		    }
		}return order;
	}
	public double getPricePowAverage(int[] theArray, int theStartIndex, int theEndIndex) {
		int pricePowSum = 0;
		int count = 0;
		for (int i = theStartIndex; i <= theEndIndex; i++) {
			pricePowSum += Math.pow(theArray[i],2);
			count++;
		}
		double pricePowAverage1 = pricePowSum/count;
		return pricePowAverage1;
	}

	public double getAverage(int[] theArray, int theStartIndex, int theEndIndex) {
		int priceSum = 0;
		int count = 0;
		for (int i = theStartIndex; i <= theEndIndex; i++) {
			priceSum += theArray[i] ;
			count++;
		}
		double priceAverage = priceSum/count;
		double pricePowAverage2 = Math.pow(priceAverage, 2);
		return pricePowAverage2;
	}
	public double getMovingAverage(int[] theArray, int theStartIndex, int theEndIndex) {
		int priceSum = 0;
		int count = 0;
		for (int i = theStartIndex; i <= theEndIndex; i++) {
			priceSum += theArray[i] ;
			count++;
		}
		double priceAverage = priceSum/count;
		return priceAverage;
	}
}