/*

 Copyright (c) 1999 Hiroshi Sato
 Copyright (c) 2000 Rikiya Fukumoto
 Copyright (c) 2002 U-Mart Project

 Permission is hereby granted, free of charge, to any person obtaining
 a copy of this software and associated documentation files (the 
 "Software"), to deal in the Software without restriction, including 
 without limitation the rights to use, copy, modify, merge, publish, 
 distribute, sublicense, and/or sell copies of the Software, and to 
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 The above copyright notice and this permission notice shall be 
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 ---------------------------------------------------------------------

 TestStrategy.java                    2002/01/31

 A class describing an agent's strategy, which buys or sells randomly.
 The limit price is set randomly around the latest futures price, and
 quantity of the order is set randomly within a prescribed range.
 Position of the agent is also considered in decision making.

 This strategy is same with RandomStrategy.java in the example strategy set.

 */

package strategy;

import java.io.*;
import java.util.*;

/*
 * 쐬: 2005/09/04
 *
 * TODO ̐ꂽt@C̃ev[gύXɂ͎փWv:
 * EBhE - ݒ - Java - R[hEX^C - R[hEev[g
 */

/**
 * @author Minoru Sasaki
 * 
 * TODO ̐ꂽ^Rg̃ev[gύXɂ͎փWv: EBhE - ݒ - Java - R[hEX^C -
 * R[hEev[g
 */

public class T02_Trend_fuzzyStrategy extends Strategy {

	private Random random;

	int numberOfDivisionMembership = 5; //o[Vbv֐̕

	int numberOfInputData = 3; //̓f[^

	double membershipFunctionForFuzzySet[][] = new double[numberOfInputData][numberOfDivisionMembership];//ʂ̔z

	int x[] = new int[numberOfInputData];

	int SN = 0;

	int N = 1;

	int Z = 2;

	int P = 3;

	int SP = 4;

	int numberOfRules = 125; //3͂̎̍ő僋[(53)

	ArrayList buySellList = new ArrayList();//ߋŐV̂Q񕪂BuySelli[

	int pos_pre;//Õ|WVcp

	private final int maxPosition = 220;//|WV̍ől

	double adaptiveValue[] = new double[numberOfRules];

	int BuySell; //0;ȂA1; 2;

	int price = 0;

	double weight[][] = new double[2][numberOfRules];

        public T02_Trend_fuzzyStrategy(int seed) {
		random = new Random(seed);
		readFile(numberOfRules, weight);
	}

	public Order getOrder(int[] spotPrices, int[] futurePrices, int pos,
			long money, int restDay) {

		Order order = new Order();

		double totalOfMyuForBuy = 0.0;

		double totalOfMyuForSell = 0.0;

		double totalOfMyu = 0.0;

		double Buy = 0.0;

		double Sell = 0.0;

		final double alpha = 0.1;
		double beta1 = 2.9;//ʌvZ̏d݂P
		double beta2 = 0.1;//ʌvZ̏d݂Q

		final int allDay = 240; //̑񂹉

		int spreadPrice = futurePrices[59] - spotPrices[119];//
		int spotSpread = spotPrices[119] - spotPrices[118];//i̍

		//
		int preQuant = (int) (Math.abs(spotSpread) * beta1)
				- (int) (beta2 * pos);
		int quant = Math.min(preQuant, 95);
		if (pos > 220 && BuySell == 2) {
			quant = 100;
		} else if (pos > 100 && BuySell == 2) {
			quant = 40;
		} else if (pos < -100 && BuySell == 1) {
			quant = 40;
		} else if (pos < -220 && BuySell == 1) {
			quant = 100;
		}

		if (restDay == 240) {

			BuySell = 0;
			buySellList.add(new Integer(BuySell));
			return order;

		} else if (restDay < 239) {
			// Debuged by isao
			if (buySellList.size() == 0) {
				System.out.println("Error (Before buySellList#remove, Rest days = " + restDay 
                           + "): buySellList.size() == 0 in T02_Trend_fuzzyStrategy#getOrder");
				order.buysell = Order.NONE;
				return order;
			}
			/////////////////////////

			buySellList.remove(0);

			// Debuged by isao
			if (buySellList.size() == 0) {
				System.out.println("Error (After buySellList#remove, Rest days = " + restDay 
                           + "): buySellList.size() == 0 in T02_Trend_fuzzyStrategy#getOrder");
				order.buysell = Order.NONE;
				return order;
			}
			////////////////////////

			int buysell = Integer.parseInt(buySellList.get(0).toString());
			if (pos_pre != pos) {
				if ((buysell == 2) && (futurePrices[58] < spotPrices[118])) {
					for (int i = 0; i < numberOfRules; i++) {
						weight[0][i] += (alpha * (1 - weight[0][i]) * adaptiveValue[i]);
						weight[0][i] = Math.min(weight[0][i], 0.999);//d݂̏tB^[
					}
				} else if ((buysell == 2)
						&& (futurePrices[58] > spotPrices[118])) {
					for (int i = 0; i < numberOfRules; i++) {
						weight[0][i] -= (alpha * (weight[0][i]) * adaptiveValue[i]);
						weight[0][i] = Math.max(weight[0][i], 0.001);//d݂̉tB^[
					}
				} else if ((buysell == 1)
						&& (futurePrices[58] > spotPrices[118])) {
					for (int i = 0; i < numberOfRules; i++) {
						weight[1][i] += (alpha * (1 - weight[0][i]) * adaptiveValue[i]);
						weight[1][i] = Math.min(weight[1][i], 0.999);//d݂̏tB^[
					}
				} else if ((buysell == 1)
						&& (futurePrices[58] < spotPrices[118])) {
					for (int i = 0; i < numberOfRules; i++) {
						weight[1][i] -= (alpha * (weight[0][i]) * adaptiveValue[i]);
						weight[1][i] = Math.max(weight[1][i], 0.001);//d݂̉tB^[
					}
				}
			}
		} else {
			BuySell = 0;
			buySellList.add(new Integer(BuySell));
		}

		//1OƂ̍A2OƂ̍A3OƂ̍
		x[0] = spotPrices[119] - spotPrices[119 - 1];
		x[1] = spotPrices[119] - spotPrices[119 - 2];
		x[2] = spotPrices[119] - spotPrices[119 - 3];

		pos_pre = pos;//|WV̍XV

		membership();//o[Vbv֐̓

		int rule = 0;
		for (int i = 0; i < numberOfDivisionMembership; i++) {
			for (int j = 0; j < numberOfDivisionMembership; j++) {
				for (int k = 0; k < numberOfDivisionMembership; k++) {
					adaptiveValue[rule] = membershipFunctionForFuzzySet[0][i] * membershipFunctionForFuzzySet[1][j] * membershipFunctionForFuzzySet[2][k];
					rule = rule + 1;
				}
			}
		}

		//ʂ̌vZEf
		for (int i = 0; i < numberOfRules; i++) {
			totalOfMyu = totalOfMyu + adaptiveValue[i];
			totalOfMyuForBuy = totalOfMyuForBuy
					+ (weight[0][i] * adaptiveValue[i]);
			totalOfMyuForSell = totalOfMyuForSell
					+ (weight[1][i] * adaptiveValue[i]);
		}
		Buy = totalOfMyuForBuy / totalOfMyu;
		Sell = totalOfMyuForSell / totalOfMyu;

		if (Buy > Sell) {
			BuySell = 2; // (2)
			buySellList.add(new Integer(BuySell));
			price = spotPrices[119] - 8;//̒l͏ƎʂāAnCXNnC^[
		} else if (Buy < Sell) {
			BuySell = 1; // (1)
			buySellList.add(new Integer(BuySell));
			price = spotPrices[119] + 8;
		} else if (Buy == Sell) {
			BuySell = 0; // Ȃ(0)
			buySellList.add(new Integer(BuySell));
		}

		//		XVd݂̃t@Co
		/*
		 * if (restDay == 1) { writeFile(totalrule, weight); }
		 */

		//|WV댯ʏ
		if (BuySell == 2) {
			if (pos > maxPosition) {
				order.buysell = Order.NONE;
				return order;
			}
		} else if (BuySell == 1) {
			if (pos < -maxPosition) {
				order.buysell = Order.NONE;
				return order;
			}
		}

		order.buysell = BuySell;
		order.quant = quant;
		order.price = price;
		return order;
	}

	//o[Vbv֐̌`
	public void membership() {

		for (int i = 0; i < numberOfInputData; i++) {

			double inner = 20; //inner̓o[Vbv֐̓臒l
			double outer = 45; //outer̓o[Vbv֐̊O臒l

			if (x[i] <= -outer) {
				membershipFunctionForFuzzySet[i][SN] = 1.0;
				membershipFunctionForFuzzySet[i][N] = 0.0;
				membershipFunctionForFuzzySet[i][Z] = 0.0;
				membershipFunctionForFuzzySet[i][P] = 0.0;
				membershipFunctionForFuzzySet[i][SP] = 0.0;
			} else if (x[i] <= -inner) {
				membershipFunctionForFuzzySet[i][SN] = ((1.0 / (inner - outer)) * x[i])
						+ (inner / (inner - outer));
				membershipFunctionForFuzzySet[i][N] = ((1.0 / (outer - inner)) * x[i])
						+ (outer / (outer - inner));
				membershipFunctionForFuzzySet[i][Z] = 0.0;
				membershipFunctionForFuzzySet[i][P] = 0.0;
				membershipFunctionForFuzzySet[i][SP] = 0.0;
			} else if (x[i] <= 0) {
				membershipFunctionForFuzzySet[i][SN] = 0.0;
				membershipFunctionForFuzzySet[i][N] = -(1.0 / inner) * x[i];
				membershipFunctionForFuzzySet[i][Z] = ((1.0 / inner) * x[i]) + 1.0;
				membershipFunctionForFuzzySet[i][P] = 0.0;
				membershipFunctionForFuzzySet[i][SP] = 0.0;
			} else if (x[i] <= inner) {
				membershipFunctionForFuzzySet[i][SN] = 0.0;
				membershipFunctionForFuzzySet[i][N] = 0.0;
				membershipFunctionForFuzzySet[i][Z] = (-(1.0 / inner) * x[i]) + 1.0;
				membershipFunctionForFuzzySet[i][P] = (1.0 / inner) * x[i];
				membershipFunctionForFuzzySet[i][SP] = 0.0;
			} else if (x[i] <= outer) {
				membershipFunctionForFuzzySet[i][SN] = 0.0;
				membershipFunctionForFuzzySet[i][N] = 0.0;
				membershipFunctionForFuzzySet[i][Z] = 0.0;
				membershipFunctionForFuzzySet[i][P] = (-(1.0 / (outer - inner)) * x[i])
						+ (outer / (outer - inner));
				membershipFunctionForFuzzySet[i][SP] = ((1.0 / (outer - inner)) * x[i])
						+ (-inner / (outer - inner));
			} else if (x[i] > outer) {
				membershipFunctionForFuzzySet[i][SN] = 0.0;
				membershipFunctionForFuzzySet[i][N] = 0.0;
				membershipFunctionForFuzzySet[i][Z] = 0.0;
				membershipFunctionForFuzzySet[i][P] = 0.0;
				membershipFunctionForFuzzySet[i][SP] = 1.0;
			}

		}
	}

	public void writeFile(int totalrule, double weight[][]) {
		try {
			PrintWriter out = new PrintWriter(new BufferedWriter(
					new FileWriter("weightupgrade.txt")));

			for (int i = 0; i < 2; i++) {
				for (int j = 0; j < totalrule; j++) {
					out.println(weight[i][j]);
				}
			}
			out.close();
		} catch (IOException ex) {

		}

	}

	public void readFile(int totalrule, double weight[][]) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(
					"weightupgrade.txt"));
			for (int i = 0; i < 2; i++) {
				for (int j = 0; j < totalrule; j++) {
					weight[i][j] = Double.parseDouble(br.readLine());
				}
			}
			br.close();
		} catch (IOException ex) {

		}
	}
}
